<TeXmacs|1.0.6.14>

<style|article>

<\body>
  <doc-data|<doc-title|<with|font-base-size|9| Ecuaciones en Derivadas
  Parciales y Anlisis Numrico>>>

  <\with|par-mode|center>
    <with|font-base-size|14|<strong|Pr<em|<strong|>>cticas>>
  </with>

  \;

  <\with|font-base-size|11>
    <\with|font-series|bold>
      <with|font-family|ss|Captulo 3. Diferencias finitas para la ecuacin
      del calor.>
    </with>
  </with>

  \;

  <\with|font-size|1.19>
    <with|font-series|bold|font-family|ss|3.1 Resolviendo la ecuacin del
    calor>
  </with>

  Vamos a resolver la ecuacin del calor utilizando un mtodo de diferencias
  finitas. Como veremos, podemos aprovechar las ideas que utilizamos con las
  ecuaciones diferenciales ordinarias. Centrmonos en la ecuacin del calor
  sin fuentes de calor:

  \;

  <\with|par-mode|center>
    <with|mode|math|u<rsub|t>-k*u<rsub|x*x>=0>
  </with>

  \;

  en una dimensin espacial, en el intervalo <math|[0,1]>, para tiempos entre
  <math|0> y <math|t<rsub|f>>, con condiciones de contorno tipo Dirichlet:

  <\with|par-mode|center>
    <with|mode|math|<tabular|<tformat|<table|<row|<cell|u(0,t)=0>|<cell|>|<cell|u(1,t)=0>>>>>>
  </with>

  y con condicin inicial:

  <\with|par-mode|center>
    <with|mode|math|u(x,0)=x(1-x)>
  </with>

  \;

  Para resolver la ecuacin, la interpretamos como un sistema de ecuaciones
  diferenciales ordinarias (EDOs) en las que un valor inicial
  <math|u<rsup|0>(x)=u(x,0)> evoluciona segn una EDO. Para ello es necesario
  utilizar una versin <em|discreta> de este valor inicial para poder
  representarlo en el ordenador mediante un vector. Descomponemos el
  intervalo <math|[0,1]> en <math|M> partes iguales, obteniendo un mallado
  uniforme <math|x<rsub|1>=0,\<ldots\>,x<rsub|m+1>=x<rsub|1>+m/M,x<rsub|M+1>=1>,
  y consideramos los valores de <math|u> slo en esos puntos. Como dato
  inicial tomamos el vector:

  \;

  <\with|par-mode|center>
    <math|<wide|u|^><rsup|0>=(<wide|u|^><rsup|0><rsub|m>)<rsub|m=1><rsup|M+1>,
    \ \ <wide|u|^><rsup|0><rsub|m>=x<rsub|m>*(1-x<rsub|m>)>
  </with>

  \;

  Nuestro objetivo es encontrar valores <math|<wide|u|^><rsub|m>(t)> que
  aproximen el valor de la funcin <math|u> en el punto <math|x<rsub|m>> y en
  el instante <math|t>. Los valores de <math|u> en los puntos
  <math|x<rsub|1>> y <math|x<rsub|M+1>> son datos del problema (los datos de
  contorno), de modo que slo falta encontrar valores que aproximen <math|u>
  en los puntos desde <math|x<rsub|2>> hasta <math|x<rsub|M>> (un total de
  <math|M-1> puntos).

  \ Representamos las derivadas espaciales mediante un operador discreto que
  acte sobre vectores de <math|\<bbb-R\><rsup|M-1>>. Definimos
  <math|h\<equallim\>1/M> y utilizamos diferencias centradas para aproximar
  la segunda derivada de <math|u>:

  <\with|par-mode|center>
    <math|D(<wide|u|^>)<rsub|m>=<frac|1|h<rsup|2>>(<wide|u|^><rsub|m-1>-2<wide|u|^><rsub|m>+<wide|u|^><rsub|m+1>)>
  </with>

  \;

  El operador <math|D> se representa por la matriz:

  \;

  <\with|par-mode|center>
    <math|D(<wide|u|^>)=<frac|1|h<rsup|2>><left|(><tabular|<tformat|<table|<row|<cell|-2>|<cell|
    \ \ \ \ \ \ \ \ \ 1>|<cell| \ \ \ 0>|<cell|>>|<row|<cell|
    \ \ \ \ \ \ \ \ \ 1>|<cell|-2>|<cell|
    \ \ \ \ \ 1>|<cell|>>|<row|<cell|>|<cell|>|<cell|\<ldots\>>|<cell|
    \ \ \ \ \ \ \ \ \ >>|<row|<cell|>|<cell|
    \ \ \ \ \ \ \ \ \ 1>|<cell|-2>|<cell|
    \ \ \ \ \ \ \ \ \ 1>>|<row|<cell|>|<cell|>|<cell|
    \ \ \ \ \ \ \ \ \ \ 1>|<cell|-2>>>>><right|)>\<cdot\><wide|u|^>>
  </with>

  \;

  Observa con atencin la primera y la ltima fila, donde se ha utilizado la
  condicin de frontera

  <\with|par-mode|center>
    <math|D(<wide|u|^>)<rsub|2>=<frac|1|h<rsup|2>>(<wide|u|^><rsub|1>-2<wide|u|^><rsub|2>+<wide|u|^><rsub|3>)=<frac|1|h<rsup|2>>(-2<wide|u|^><rsub|2>+<wide|u|^><rsub|3>)>
  </with>

  <\with|par-mode|center>
    <math|D(<wide|u|^>)<rsub|M>=<frac|1|h<rsup|2>>(<wide|u|^><rsub|M-1>-2<wide|u|^><rsub|M>+<wide|u|^><rsub|M+1>)=<frac|1|h<rsup|2>>(<wide|u|^><rsub|M-1
    >-2<wide|u|^><rsub|M>)>
  </with>

  \;

  Ahora la EDO para <math|<wide|u|^>> es:

  <\with|par-mode|center>
    <math|<frac|d|d t><wide|u|^>=k D(<wide|u|^>)>
  </with>

  <\with|par-mode|center>
    <math|<wide|u|^>(0)=<wide|u|^><rsup|0>>
  </with>

  \;

  y la podemos resolver de forma aproximada utilizando cualquiera de los
  mtodos vistos para EDOs. Por ejemplo, si usamos el mtodo de Euler
  explcito, obtenemos el algoritmo:

  \;

  <\with|par-mode|center>
    <math|<wide|u|^><rsup|n+1>=<wide|u|^><rsup|n>+ dt*\<cdot\>k
    D(<wide|u|^><rsup|n>)=(I+ dt*\<cdot\>k D)(<wide|u|^><rsup|n>)>
  </with>

  \;

  Escribimos un script de matlab que implementa la idea anterior. El script
  toma los datos relevantes del problema y devuelve vectores
  <math|<wide|u|^><rsup|n>> que aproximan <math|<wide|u|^>(t<rsub|n>)> para
  algunos valores tiempos.

  <\code>
    function [u_save,x,t_save]=calor(k, M, t_f, tsteps)

    %function [u_save,x,t_save]=calor(k, M, t_f, tsteps)

    %

    %resuelve la ecuacion del calor u_t = k u_xx en [0,1] con dato inicial
    x(1-x)

    %y condiciones de contorno tipo Dirichlet u(0,t)=u(1,t)=0

    %

    %Datos de entrada:

    % k: coeficiente k de la ecuacion

    % M: numero de partes iguales en que se descompone [0,1]

    % t_f: instante de tiempo hasta el que calculamos la solucion

    % tsteps: numero de partes iguales en que se descompone [0,t_f]

    \;

    %Mallado

    dt=t_f/tsteps;

    tiempos=0:dt:t_f;

    h=1/M;

    x=0:h:1;

    \;

    %Datos iniciales

    xred=x(2:M); %quitamos los extremos del vector x\ 

    u=(xred.*(1-xred))'; %trasponemos para obtener un vector columna

    \;

    %El operador D

    %Usamos el comando diag(vector,k) para crear una matriz tridiagonal

    Tridiag=diag(-2*ones(M-1,1))+diag(ones(M-2,1),1)+diag(ones(M-2,1),-1);

    D=(1/h^2)*Tridiag;

    \;

    %Datos de salida: en vez de guardar todos los datos intermedios,
    guardamos el %vector u solo Nframes veces.

    Nframes=5;

    marca=floor(tsteps/(Nframes-1));

    u_save=zeros(M+1,Nframes);\ 

    t_save=zeros(1,Nframes);

    %Le ponemos las condiciones de frontera\ 

    u_save(1,:)=zeros(1,Nframes);\ 

    u_save(M+1,:)=zeros(1,Nframes);

    %guardamos la posicion de partida

    u_save(2:M,1)=u;

    t_save(1)=0;

    \;

    %Bucle principal

    I=eye(M-1);

    A=(I+dt*k*D);

    for n=1:tsteps

    \ \ \ \ u=A*u;

    \ \ \ \ %Guardamos los valores de u para algunos tiempos

    \ \ \ \ if mod(n,marca)==0

    \ \ \ \ \ \ indice=1+n/marca;

    \ \ \ \ \ \ u_save(2:M,indice)=u;

    \ \ \ \ \ \ t_save(indice)=tiempos(n);

    \ \ \ \ end

    end
  </code>

  <\with|font-size|1.19>
    <with|font-series|bold|font-family|ss|3.2 Representar la solucin>

    \;
  </with>

  Al llamar al cdigo anterior con datos concretos:

  <\with|par-mode|center>
    <\code>
      [u,x,t]=calor(.1, 20, 1, 1000);
    </code>
  </with>

  recuperamos el vector con las posiciones <with|font-family|tt|x>, los
  instantes de tiempo <with|font-family|tt|t(1)<with|font-family|rm|, ...
  ,>t(Nframes)> en que se ha guardado la solucin, y los vectores
  <with|font-family|tt|u(n)> que aproximan <math|<wide|u|^>(t(n))> para esos
  tiempos. Para representar la solucin en el instante
  <with|font-family|tt|t(n)> escribimos:

  <\code>
    plot(x,u(:,n));
  </code>

  Si queremos ver cmo evoluciona la temperatura, podemos dibujar todos los
  vectores <with|font-family|tt|u(n)> a la vez:

  <\code>
    plot(x,u)
  </code>

  <strong|Ejercicio>: vuelve a ejecutar el cdigo anterior con otra condicin
  inicial distinta. Dibuja el resultado. Qu ocurre si la condicin inicial
  no satisface la condicin de frontera?

  \;

  <\with|font-size|1.19>
    <with|font-series|bold|font-family|ss|3.3 Estabilidad del mtodo>
  </with>

  \;

  Vamos a calcular la solucin hasta <math|t<rsub|f>=1> con
  <with|mode|math|M=100>, <with|mode|math|*tsteps=1000>,
  <with|mode|math|k=0.1>.

  Para ello escribe:

  <\with|par-mode|center>
    <\code>
      [u,x,t]=calor(.1, 100, 1, 1000);
    </code>
  </with>

  y dibuja la solucin.

  Como podemos comprobar, el resultado es altamente oscilatorio y la
  temperatura toma valores enormes, cosa que no es fsicamente razonable. El
  problema est en la eleccin del paso temporal. Recordamos que para que el
  esquema numrico sea estable se debe cumplir

  \;

  <\with|par-mode|center>
    <math|><with|mode|math|s=k<frac|d*t|h<rsup|2>>\<less\><frac|1|2>>
  </with>

  \;

  Si tomamos <math|M=100>, el paso temporal debe verificar <math|d
  t\<less\><frac|1|2><frac|1|0.1><left|(><frac|1|100><right|)><rsup|2>=5
  \<cdot\> 10<rsup|-4>>. Como ejercicio, puedes comprobar que en este caso la
  cota es exacta, y valores de <math|d t> ligeramente superiores producirn
  una solucin inestable mientras que valores ligeramente inferiores producen
  una aproximacin decente (el valor crtico de <math|tsteps> es 2000).

  \;

  <\with|font-size|1.19>
    <with|font-series|bold|font-family|ss|3.4 Un problema ms complejo>
  </with>

  \;

  Vamos a estudiar ahora una situacin un poco ms complicada.\ 

  La ecuacin que vimos en el apartado 3.1 se puede usar para representar la
  temperatura en una barra de metal cuyo cuerpo est aislado y no recibe
  calor de ninguna fuente pero cuyos extremos se mantienen a temperatura
  cero.\ 

  El ejemplo que veremos ahora corresponde a una barra cuyos extremos estn
  aislados y que recibe calor de una fuente externa. En concreto, queremos
  estudiar cmo se calienta una barra con temperatura inicial <math|0> y los
  extremos aislados cuando calentamos la mitad izquierda de la barra.

  De nuevo estudiamos el problema en una dimensin espacial, en el intervalo
  <math|[0,1]>, para tiempos entre <math|0> y <math|t<rsub|f>>. Para
  comenzar, debemos aadir una fuente de calor a la ecuacin del calor:

  \;

  <\with|par-mode|center>
    <with|mode|math|u<rsub|t>-k*u<rsub|x*x>=f(t,x)>
  </with>

  \;

  Tomaremos la fuente de calor constante en el tiempo y de intensidad
  <math|1> o <math|0> dependiendo de si estamos en la primera mitad de la
  barra o en la segunda:

  \;

  <\with|par-mode|center>
    <math|><math|f(t,x)=<left|{><tabular|<tformat|<table|<row|<cell|1
    \ \ \ si x\<less\><frac|1|2>>>|<row|<cell|0 \ \ si
    x\<geq\><frac|1|2>>>>>>>
  </with>

  \;

  Adems de la fuente de calor, tenemos condiciones de contorno tipo Neumann
  homogneas:

  \;

  <\with|par-mode|center>
    <math|<frac|\<partial\>u|\<partial\>x>(t,0)=<frac|\<partial\>u|\<partial\>x>(t,1)=0>
  </with>

  \;

  que representan que no hay flujo de calor en los extremos de la barra.

  Del mismo modo que antes, interpretamos la ecuacin como un sistema de
  ecuaciones diferenciales ordinarias (EDOs) en las que el valor inicial
  <math|u<rsup|0>(x)=u(x,0)> evoluciona segn una EDO. \ De nuevo buscamos
  representar una funcin <math|u(x)> de una variable <math|x> mediante un
  vector. Para ello descomponemos el intervalo <math|[0,1]> en <math|M>
  partes iguales, obteniendo un mallado uniforme
  <math|x<rsub|1>=0,\<ldots\>,x<rsub|m+1>=x<rsub|1>+m/M,x<rsub|M+1>=1>, y
  consideramos los valores de <math|u> slo en esos puntos. Tomamos como dato
  inicial el vector

  \;

  <\with|par-mode|center>
    <math|<wide|u|^><rsup|0><rsub|m>=0 \ \ \ \ \ \ \<forall\>m=1,\<ldots\>
    ,M+1>
  </with>

  \;

  Nuestro objetivo es encontrar valores <math|<wide|u|^><rsub|m>(t)> que
  aproximen el valor de la funcin <math|u> en el punto <math|x<rsub|m>> y en
  el instante <math|t>. Los valores en los puntos <math|x<rsub|1>> y
  <math|x<rsub|M+1>> ya no son datos del problema, de modo que sta vez
  tenemos que encontrar valores que aproximen <math|u> en los puntos desde
  <math|x<rsub|1>> hasta <math|x<rsub|M+1>> (un total de <math|M+1> puntos).

  \ Representamos las derivadas espaciales mediante un operador discreto que
  acte sobre vectores de <math|\<bbb-R\><rsup|M+1>>. Definimos
  <math|h\<equallim\>1/M> y utilizamos la misma aproximacin de antes para la
  segunda derivada de <math|u>

  \ 

  <\with|par-mode|center>
    <math|D(<wide|u|^><rsub|m>)=<frac|1|h<rsup|2>>(<wide|u|^><rsub|m-1>-2<wide|u|^><rsub|m>+<wide|u|^><rsub|m+1>)>
  </with>

  \;

  Sin embargo, tendremos que trabajar un poco ms para encontrar las
  ecuaciones en los extremos del intervalo. Utilizando una diferencia
  centrada podemos aproximar la condicin en la frontera:

  <\with|par-mode|center>
    0=<math|<frac|\<partial\>u|\<partial\>x>(x<rsub|1>,t)\<approx\><frac|1|2h>(u(x<rsub|1>+h,t)-u(x<rsub|1>-h,t))>
  </with>

  <\with|par-mode|center>
    0=<math|<frac|\<partial\>u|\<partial\>x>(x<rsub|M+1>,t)\<approx\><frac|1|2h>(u(x<rsub|M+1>+h,t)-u(x<rsub|M+1>-h,t))>
  </with>

  \;

  <\with|par-mode|center>
    <math|0=<frac|1|2h>(u<rsub|2>(t)-u<rsup|*\<ast\>><rsub|0>(t))>
  </with>

  <\with|par-mode|center>
    <math|0=<frac|1|2h>(u<rsup|\<ast\>><rsub|M+2>(t)-u<rsub|M>(t))>
  </with>

  \;

  Al hacerlo aparece la funcin <math|u> evaluada en el punto
  <math|x<rsub|1>-h> (el punto <math|x<rsub|0>>, en cierto sentido), que no
  pertenece al intervalo, pero este punto tambin aparece al utilizar la
  aproximacin a <math|D<rsup|2>(<wide|u|^>)<rsub|1>>, de modo que podemos
  cancelar ambas apariciones para obtener las aproximaciones:

  \;

  <\with|par-mode|center>
    <math|D(<wide|u|^>)<rsub|1>=<frac|1|h<rsup|2>>(<wide|u|^><rsup|\<ast\>><rsub|0>-2<wide|u|^><rsub|1>+<wide|u|^><rsub|2>)=<frac|1|h<rsup|2>>(-2<wide|u|^><rsub|1>+2<wide|u|^><rsub|2>)>
  </with>

  <\with|par-mode|center>
    <math|D(<wide|u|^>)<rsub|M+1>=<frac|1|h<rsup|2>>(<wide|u|^><rsub|M>-2<wide|u|^><rsub|M+1>+<wide|u|^><rsup|\<ast\>><rsub|M+2>)=<frac|1|h<rsup|2>>(2<wide|u|^><rsub|M>-2<wide|u|^><rsub|M+1>)>
  </with>

  \;

  De este modo, el operador <math|D> se representa por la matriz:

  \;

  <\with|par-mode|center>
    <math|D(<wide|u|^>)=<frac|1|h<rsup|2>><left|(><tabular|<tformat|<table|<row|<cell|-2>|<cell|
    \ \ \ \ \ \ \ \ \ 2>|<cell| \ \ \ 0>|<cell|>>|<row|<cell|
    \ \ \ \ \ \ \ \ \ 1>|<cell|-2>|<cell|
    \ \ \ \ \ 1>|<cell|>>|<row|<cell|>|<cell|>|<cell|\<ldots\>>|<cell|
    \ \ \ \ \ \ \ \ \ >>|<row|<cell|>|<cell|
    \ \ \ \ \ \ \ \ \ 1>|<cell|-2>|<cell|
    \ \ \ \ \ \ \ \ \ 1>>|<row|<cell|>|<cell|>|<cell|
    \ \ \ \ \ \ \ \ \ 2>|<cell|-2>>>>><right|)>\<cdot\><wide|u|^>>
  </with>

  \;

  \;

  La fuente de calor <math|f >es ms fcil de representar: es slo un vector
  de longitud <math|M+1> con las primeras <math|<frac|M+1|2>> entradas
  iguales a 1 y las siguientes iguales a <math|0>.

  De este modo, la EDO para <math|<wide|u|^>> es:

  \;

  <\with|par-mode|center>
    <math|<frac|d|d t><wide|u|^>=k D(<wide|u|^>)+f>
  </with>

  <\with|par-mode|center>
    <math|<wide|u|^>(0)=<wide|u|^><rsup|0>>
  </with>

  \;

  Volvemos a usar el mtodo de Euler explcito, que en este caso da lugar a:

  \;

  <\with|par-mode|center>
    <math|<wide|u|^><rsup|n+1>=<wide|u|^><rsup|n>+ d t*\<cdot\>(k
    D(<wide|u|^><rsup|n>) +f)=(I+d t \<cdot\>k D)<wide|u|^><rsup|n>+ d
    t*\<cdot\>f>
  </with>

  \;

  Adaptamos el cdigo anterior a la nueva situacin:

  <\code>
    function [u_save,x,t_save]=calor2(k, M, t_f, tsteps)

    %function [u_save,x,t_save]=calor2(k, M, t_f, tsteps)

    %

    %resuelve la ecuacion del calor u_t = k u_xx + f en [0,1] con dato
    inicial 0

    %y condiciones de contorno tipo Neumann homogeneas

    %

    %Datos de entrada:

    % k: coeficiente k de la ecuacion

    % M: numero de partes iguales en que se descompone [0,1]

    % t_f: instante de tiempo hasta el que calculamos la solucion

    % tsteps: numero de partes iguales en que se descompone [0,t_f]

    \;

    %Mallado

    dt=t_f/tsteps;

    tiempos=0:dt:t_f;

    h=1/M;

    x=0:h:1;

    \;

    %Datos iniciales

    u=zeros(M+1,1);

    \;

    %El operador D

    %Usamos el comando diag(vector,k) para crear una matriz tridiagonal

    Tridiag=diag(-2*ones(M+1,1))+diag(ones(M,1),1)+diag(ones(M,1),-1);

    Tridiag(1,2)=2;

    Tridiag(M+1,M)=2;

    D=(1/h^2)*Tridiag;

    \;

    %El vector f

    mitad=floor((M+1)/2);

    f=[ones(mitad,1); zeros(M+1-mitad,1)];

    \;

    %Datos de salida: en vez de guardar todos los datos intermedios,
    guardamos el %vector u solo Nframes veces.

    Nframes=5;

    marca=floor(tsteps/(Nframes-1));

    u_save=zeros(M+1,Nframes);\ 

    t_save=zeros(1,Nframes);

    %guardamos la posicion de partida

    u_save(:,1)=u;

    t_save(1)=0;

    \;

    %Bucle principal

    I=eye(M+1);

    A=(I+dt*k*D);

    b=dt*f;

    for n=1:tsteps

    \ \ \ \ u=A*u+b;

    \ \ \ \ %Guardamos los valores de u para algunos tiempos

    \ \ \ \ if mod(n,marca)==0

    \ \ \ \ \ \ indice=1+n/marca;

    \ \ \ \ \ \ u_save(:,indice)=u;

    \ \ \ \ \ \ t_save(indice)=tiempos(n);

    \ \ \ \ end

    end
  </code>

  Probemos el resultado:

  <\with|par-mode|left>
    <\code>
      [u,x,t]=calor2(.05, 20, 1, 1000);

      plot(x,u)
    </code>
  </with>
</body>

<\initial>
  <\collection>
    <associate|sfactor|4>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|auto-1|<tuple|1|?>>
  </collection>
</references>